#ifndef CONSOLAWF2MAT_H
#define CONSOLAWF2MAT_H

#include "genfile.h"
#include "aliast.h"

class con_awf2mat
{
 public:
  con_awf2mat();    //constructor
  ~con_awf2mat();   //destructor

  void read(XFILE *in);
  void print(FILE *out);
  
  void matcond (matrix &d,long ri,long ci,long ipp);
  void matcap (double &c,long ri,long ci,long ipp);
  
  void matcond1d (matrix &d,long ri,long ci,long ipp);
  void matcond2d (matrix &d,long ri,long ci,long ipp);
  void matcond3d (matrix &d,long ri,long ci,long ipp);

  void rhs_volume (matrix &d,long ri,long ci,long ipp);
  void rhs1d1 (matrix &d,long ri,long ci,long ipp);
  void rhs2d1 (matrix &d,long ri,long ci,long ipp);
  void rhs3d1 (matrix &d,long ri,long ci,long ipp);

  double get_sw(double pw, double pg, long ipp);
  double get_cs(double pw, double pg, long ipp);
  double get_se(double sw);
  double get_krw(double pw, double pg, long ipp);
  double get_krg(double pw, double pg, long ipp);

  double get_kww(double pw, double pg, long ipp);
  double get_kwg(double pw, double pg, long ipp);
  double get_kgw(double pw, double pg, long ipp);
  double get_kgg(double pw, double pg, long ipp);

  double get_capww(double pw, double pg, long ipp);
  double get_capwg(double pw, double pg, long ipp);
  double get_capgw(double pw, double pg, long ipp);
  double get_capgg(double pw, double pg, long ipp);

  double get_fw1(double pw, double pg, long ipp);
  double get_fg1(double pw, double pg, long ipp);

  double get_othervalue(long compother,double pw, double pg, long ipp);
  void print_othervalue_name(FILE *out,long compother);
  void values_correction (vector &nv, long ipp);
  void water_pressure_check(double &pw,double &pg,long ipp);
  void updateval (long ipp);
  void initval(long ipp);
  
  /// returns ordered dof names
  void give_dof_names(namevart *dofname, long ntm);

  double give_water_pressure(long ipp);
  double give_gas_pressure(long ipp);
  double give_pore_pressure(long ipp);
  double give_suction(long ipp);
  double give_saturation_degree(long ipp);

  /// marks required non-transport quantities
  void give_reqntq(long *antq);


 private:
  
  airwaterflowtype model_type;
  double alpha,ks,phi0,kw,rhow,muw0,kintr,mug0;
  double p_atm;

};  

#endif
