#ifndef ELEMSWITCHT_H
#define ELEMSWITCHT_H

#include "aliast.h"
#include "galias.h"
#include "matrix.h"

void conductmat (long eid,long lcid,matrix &km);
void capacmat (long eid,long lcid,matrix &cm);

void intpointvalues (long eid);
void intpointvalues_puc (long eid);
void intpointgradients (long eid);
void intpointfluxes (long eid);
void averageflux (long lcid,long eid,vector &fl);
void intpointothers (long eid);
void intpointeqothers (long eid);

void source_vector (long lcid,long eid,vector &nodval,vector &lv);

void compute_ipfluxes ();
void compute_average_fluxes (long lcid, vector &fl);
void compute_ipgrads ();
void compute_ipotherst ();
void compute_ipeqotherst ();

void compute_nodegrads ();
void compute_nodefluxes ();
void compute_nodeotherst ();
void compute_nodeotherst_comp ();
void compute_nodeeqotherst ();
void compute_nodeeqotherst_comp ();

void internal_fluxes (double *intflux,long n);

void elem_neumann_vector (vector &lv,long lcid,long eid,long i);
void elem_newton_vector (vector &lv,long lcid,long eid,long i);
void elem_transmission_flux (vector &lv,long lcid,long eid,long i);
void volume_rhs_vector (vector &lv,long lcid,long eid);
void lmat (long eid,long lcid,matrix &lm);
void ltmat (long eid,long lcid,matrix &lm);
void averdmat (long eid,double &elemarea,matrix &km);
void avercmat (long eid,double &elemarea,matrix &cm);

double give_elemarea (long eid);

void higher_to_lower_level_elem (long eid,long *counter,double *buff);
void intpointvalt (double *gv, nontransquant ntq, double scale);
void elem_intpointvalt (long eid,vector &nodval,vector &ipval);
void give_transq_nodval (double *gv,long mnt,nonmechquant nmq);
void elem_transq_nodval (long eid, vector &nodval, nonmechquant nmq);
void elem_transq_nodval_comp (long eid, vector &nodval, long ncne, long nq, nonmechquant *qt);

///  function returns integral over a single finite element
///  variable is stored in nodes
double elem_total_integral (long eid,vector &nodval);
///  function returns integral over a single finite element
///  variable is stored in integration points
double elem_total_integral_ip (long eid,long varid);

#endif
